package com.bonus.material.task.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;
import com.bonus.common.log.enums.OperaType;
import com.bonus.material.common.annotation.PreventRepeatSubmit;
import com.bonus.material.task.domain.TmTaskAuditResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.bonus.common.log.annotation.SysLog;
import com.bonus.common.security.annotation.RequiresPermissions;
import com.bonus.material.task.domain.TmTaskAuditLog;
import com.bonus.material.task.service.ITmTaskAuditLogService;
import com.bonus.common.core.web.controller.BaseController;
import com.bonus.common.core.web.domain.AjaxResult;
import com.bonus.common.core.utils.poi.ExcelUtil;
import com.bonus.common.core.web.page.TableDataInfo;

/**
 * 任务Controller
 * 
 * @author xsheng
 * @date 2024-10-18
 */
@Api(tags = "任务接口")
@RestController
@RequestMapping("/tm_task_audit_log")
public class TmTaskAuditLogController extends BaseController {
    @Autowired
    private ITmTaskAuditLogService tmTaskAuditLogsService;

    /**
     * 查询任务列表
     */
    @ApiOperation(value = "查询任务列表")
    @RequiresPermissions("task:logs:list")
    @GetMapping("/list")
    public TableDataInfo list(TmTaskAuditLog tmTaskAuditLog) {
        startPage();
        List<TmTaskAuditLog> list = tmTaskAuditLogsService.selectTmTaskAuditLogsList(tmTaskAuditLog);
        return getDataTable(list);
    }

    /**
     * 导出任务列表
     */
    @ApiOperation(value = "导出任务列表")
    @PreventRepeatSubmit
    @RequiresPermissions("task:logs:export")
    @SysLog(title = "任务", businessType = OperaType.EXPORT, logType = 1,module = "仓储管理->导出任务")
    @PostMapping("/export")
    public void export(HttpServletResponse response, TmTaskAuditLog tmTaskAuditLog) {
        List<TmTaskAuditLog> list = tmTaskAuditLogsService.selectTmTaskAuditLogsList(tmTaskAuditLog);
        ExcelUtil<TmTaskAuditLog> util = new ExcelUtil<TmTaskAuditLog>(TmTaskAuditLog.class);
        util.exportExcel(response, list, "任务数据");
    }

    /**
     * 获取任务详细信息
     */
    @ApiOperation(value = "获取任务详细信息")
    @RequiresPermissions("task:logs:query")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return success(tmTaskAuditLogsService.selectTmTaskAuditLogsById(id));
    }

    /**
     * 新增任务
     */
    @ApiOperation(value = "新增任务")
    @PreventRepeatSubmit
    @RequiresPermissions("task:logs:add")
    @SysLog(title = "任务", businessType = OperaType.INSERT, logType = 1,module = "仓储管理->新增任务")
    @PostMapping
    public AjaxResult add(@RequestBody TmTaskAuditLog tmTaskAuditLog) {
        try {
            return toAjax(tmTaskAuditLogsService.insertTmTaskAuditLogs(tmTaskAuditLog));
        } catch (Exception e) {
            return error("系统错误, " + e.getMessage());
        }
    }

    /**
     * 修改任务
     */
    @ApiOperation(value = "修改任务")
    @PreventRepeatSubmit
    @RequiresPermissions("task:logs:edit")
    @SysLog(title = "任务", businessType = OperaType.UPDATE, logType = 1,module = "仓储管理->修改任务")
    @PutMapping
    public AjaxResult edit(@RequestBody TmTaskAuditLog tmTaskAuditLog) {
        try {
            return toAjax(tmTaskAuditLogsService.updateTmTaskAuditLogs(tmTaskAuditLog));
        } catch (Exception e) {
            return error("系统错误, " + e.getMessage());
        }
    }

    /**
     * 删除任务
     */
    @ApiOperation(value = "删除任务")
    @PreventRepeatSubmit
    @RequiresPermissions("task:logs:remove")
    @SysLog(title = "任务", businessType = OperaType.DELETE, logType = 1,module = "仓储管理->删除任务")
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        return toAjax(tmTaskAuditLogsService.deleteTmTaskAuditLogsByIds(ids));
    }

    /**
     * 新增任务
     */
    @ApiOperation(value = "任务审核结果")
    @PreventRepeatSubmit
    @RequiresPermissions("task:logs:audits")
    @SysLog(title = "任务审核结果", businessType = OperaType.INSERT, logType = 1,module = "仓储管理->任务审核结果")
    @PostMapping("/audits")
    public AjaxResult queryTaskAudits(@RequestBody TmTaskAuditLog tmTaskAuditLog) {
        try {
            TmTaskAuditResult tmTaskAuditResult = tmTaskAuditLogsService.getAuditResult(tmTaskAuditLog);
            return success(tmTaskAuditResult);
        } catch (Exception e) {
            return error("系统错误, " + e.getMessage());
        }
    }
}
